/*

Copyright (C) 2002 J.D. Cole

This program is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; either version 2, or (at your option) any
later version.

This program is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Octave; see the file COPYING.  If not, write to the Free
Software Foundation, 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

/*
  $Header: /home/jd/hpo/cvs-root/code/dld-projects/mpi/octave_mpi.cc,v 1.3 2002/12/11 08:23:44 jd Exp $
*/

#include <octave_mpi.h>

#include <octave/oct.h>
#include <octave/variables.h>

bool
octave_mpi_start_session(void)
{
  if (octave_mpi_verify_session())
    {
      error("mpi_init has already been called");
     
      return(false);
    }

  set_global_value("octave_mpi_session_flag",true);

  return(true);
}

bool
octave_mpi_verify_session(void)
{
  symbol_record *sr = global_sym_tab->lookup("octave_mpi_session_flag");

  if (sr)
    {
      octave_value sr_def = sr->def();
      
      if (sr->def().bool_value())
	{
	  return(true);
	}
      else if (!sr->def().bool_value())
	{
	  error("%s is false. (Session has failed to start or has been ended.)",
		"octave_mpi_session_flag");
	  
	  return(false);
	}
    }

  return(false);
}

bool
octave_mpi_end_session(void)
{
  if (!octave_mpi_verify_session())
    {
      error("mpi_init has not been started");
     
      return(false);
    }

  set_global_value("octave_mpi_session_flag",false);

  return(true);
}

